package org.artifactory.spring;

import org.artifactory.converter.ConverterManager;
import org.artifactory.test.ArtifactoryHomeBoundTest;
import org.mockito.Mockito;
import org.testng.annotations.Test;

import java.util.HashMap;
import java.util.Map;

/**
 * @author Alexei Vainshtein
 */
public class ArtifactoryApplicationContextTest extends ArtifactoryHomeBoundTest {

    @Test
    public void testContextCreated() {
        ArtifactoryApplicationContext applicationContext = Mockito.mock(ArtifactoryApplicationContext.class);
        Map<String, ContextCreationListener> contextCreationListeners = new HashMap<>();
        ContextCreationListener contextCreationListener = Mockito.mock(ContextCreationListener.class);
        contextCreationListeners.put("test", contextCreationListener);
        Mockito.when(applicationContext.beansForType(ContextCreationListener.class))
                .thenReturn(contextCreationListeners);
        Mockito.doCallRealMethod().when(applicationContext).contextCreated();
        ConverterManager converterManager = Mockito.mock(ConverterManager.class);
        Mockito.doNothing().when(converterManager).convertAsync();
        Mockito.when(applicationContext.getConverterManager()).thenReturn(converterManager);
        Mockito.when(applicationContext.getArtifactoryHome()).thenReturn(homeStub);
        applicationContext.contextCreated();
        Mockito.verify(converterManager, Mockito.times(1)).convertAsync();
    }
}