#!/usr/bin/env bash

set -e

export PROJECT_ROOT_DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" && cd ../../.. && pwd)"
source "${PROJECT_ROOT_DIR}/build/ci/scripts/lib/buildInfoUtils.sh"
source "${PROJECT_ROOT_DIR}/build/ci/scripts/lib/versionUtils.sh"
source "${PROJECT_ROOT_DIR}/build/ci/scripts/lib/mavenUtils.sh"

cd "${PROJECT_ROOT_DIR}/artifactory-oss"


function on_start() {
  local projectListArg
  local version revision
  version=$(maven_getVersionFromPom pom.xml)
  revision=$(version_getRevisionFromVersion ${version})
  export MAVEN_EXTRA_CONFIG="${MAVEN_CONFIG} -Dartifactory.revision.prop=${revision}"
  "${PROJECT_ROOT_DIR}/build/ci/scripts/javaGenerateConfig.sh"
  buildInfo_setBuildNameAndNumber
  export MVN_COMMAND="install -DskipTests ${MAVEN_EXTRA_CONFIG}"
}

function on_success() {
  local version
  version=$(maven_getVersionFromPom "pom.xml")
  buildInfo_modifyBuildName "${JFROG_CLI_BUILD_NAME}" "${JFROG_CLI_BUILD_NUMBER}"
  buildInfo_publish
  write_output artifactory_oss_java_module_build_info buildName="${JFROG_CLI_BUILD_NAME}" buildNumber="${JFROG_CLI_BUILD_NUMBER}" version="${version}"
}
