package org.artifactory.ui.rest.service.admin.configuration.general;

import org.artifactory.api.config.CentralConfigService;
import org.artifactory.descriptor.config.MutableCentralConfigDescriptor;
import org.artifactory.ui.rest.model.admin.configuration.generalconfig.ArtifactoryConfig;
import org.jetbrains.annotations.NotNull;
import org.mockito.Mockito;
import org.testng.Assert;
import org.testng.annotations.Test;

import static org.artifactory.ui.rest.service.admin.configuration.general.UpdateConfigUtils.prepareAddonsManager;
import static org.artifactory.ui.rest.service.admin.configuration.general.UpdateConfigUtils.prepareMutableCentralConfigDescriptor;

/**
 * @author Alexei Vainshtein
 */
public class UpdateArtifactoryConfigServiceTest {

    @Test
    public void testUpdateDescriptorAndSave() {
        MutableCentralConfigDescriptor descriptor = prepareMutableCentralConfigDescriptor();
        CentralConfigService testCentralConfigService = Mockito.mock(CentralConfigService.class);
        Mockito.when(testCentralConfigService.getMutableDescriptor()).thenReturn(descriptor);
        UpdateArtifactoryConfigService service =
                new UpdateArtifactoryConfigService(testCentralConfigService, prepareAddonsManager());
        Mockito.doAnswer(invocationOnMock -> {
            MutableCentralConfigDescriptor mutableCentralConfigDescriptor =
                    (MutableCentralConfigDescriptor) invocationOnMock.getArguments()[0];
            Assert.assertTrue(mutableCentralConfigDescriptor.isArchiveIndexEnabled());
            return null;
        }).when(testCentralConfigService).saveEditedDescriptorAndReload(descriptor);

        service.updateDescriptorAndSave(prepareConfig());
    }

    @NotNull
    public ArtifactoryConfig prepareConfig() {
        ArtifactoryConfig config = new ArtifactoryConfig();
        config.setArchiveIndexEnabled(true);
        config.setFileUploadMaxSize(10);
        config.setShowAddonSettings(false);
        config.setGlobalOfflineMode(true);
        config.setFolderDownloadEnabled(false);
        config.setFolderDownloadEnabled(false);
        return config;
    }
}